const uuidv4 = require('uuid/v4');
const system = require("../../../system");
const ServiceBase = require("../../sve.base");
const settings = require("../../../../config/settings");
var moment = require('moment')
class NeedinfoService extends ServiceBase {
  constructor() {
    super("dbneed", ServiceBase.getDaoName(NeedinfoService));
    this.execlient = system.getObject("util.execClient");
    this.needsolutionSve = system.getObject("service.dbneed.needsolutionSve");
    this.needsolutionDao = system.getObject("db.dbneed.needsolutionDao");
    this.needinfoDao = system.getObject("db.dbneed.needinfoDao");
  }
  async getItemByNeedNo(pobj) {
    var item = await this.dao.getItemByNeedNo(pobj.actionBody.needNo);
    console.log(system.getResultSuccess(item));
    if (!item) {
      return system.getResult(null, "需求数据为空，30210");
    }
    return system.getResultSuccess(item);
  }

  async opSubmitNeed(pobj, actionBody, req) {
    var needNo = await this.getBusUid("n");
    if (!actionBody.mobile) {
      return system.getResultFail(-5002, "mobile不能为空");
    }
    if (!actionBody.type) {
      return system.getResultFail(-5003, "type不能为空");
    }
    var nobj = {
      uapp_id: pobj.appInfo.uapp_id,
      channelNeedNo: needNo, // 2020 0807 lin 修改内容 渠道需求号改为企服通需求号 不再单独获取新的uuid
      needNo: needNo,
      channelUserId: pobj.userInfo.channel_userid,
      publishName: actionBody.userName,
      publishContent: actionBody.description,
      publishMobile: actionBody.mobile,
      city: actionBody.area,
      typeCode: actionBody.type_code,
      typeName: actionBody.type_name,
      channelTypeCode: actionBody.channel_type_code,
      channelTypeName: actionBody.channel_type_name,
      status: "wts"
    }
    await this.dao.create(nobj);
    return system.getResultSuccess();
  }

  async opNeedList(pobj, actionBody, req) {
    // 时间段，分页，排序，需求状态 条件展示未做
    var needinfo = await this.dao.model.findAll({ 
        where:{
            channelUserId: pobj.userInfo.channel_userid 
        },
        order: [["id", 'desc']],
        attributes: ["needNo", "status", "statusName"],
        raw: true
    });
    return system.getResult(needinfo);
  }

  async opNeedClose(pobj, actionBody, req) {
    var needinfo = await this.findOne({ channelNeedNo: actionBody.needNo });
    if (!needinfo) {
      return system.getResultFail(-5004, "需求不存在");
    }
    if (needinfo.status == "ygb" || needinfo.status == "ycd") {
      return system.getResultSuccess();
    } else {
      needinfo.status = "ygb";
      var self = this;
      await self.update(needinfo.dataValues);
      return system.getResultSuccess();
    }
  }
}
module.exports = NeedinfoService;

// var a=new NeedinfoService();
// var b=a.getItemByChannelSolutionNo({actionBody:{bizId:"1593141330846"}});